import es, gamethread, playerlib, popuplib, effectlib, os, math, random

sv_options = {
	'min_players_for_lr': 2,
	'announce_rebel_killed': 1,
	'max_non_rebels_kill_per_round': 3,
	'too_many_non_rebels_killed_punishment': 'takehp75',
	'announce_turn_into_rebel': 1,
	'max_innocent_kills_per_3_seconds': 3,
	'too_high_kps_punishment': 'kick',
	'unrestricted_weapons': 'm4a1,deagle,famas,aug,tmp,knife,vesthelm,vest,nvgs',
	't_start_weapons': 'deagle,knife',
	'ct_start_weapons': 'deagle,m4a1',
	'beacon_on_lr': 1,
	'allow_to_kill_for_jumping_on_head': 1,
	'strip_weapons_on_round_end': 0,
	'hosties_rebel_color': '255,255,255,255',
	'hosties_announce_lr_available': 0,
	'hosties_announce_ct_hurt_t': 0,
	'hosties_rebel_on_hurt': 0,
	'hosties_show_rules_on_join': 1,
}

es.ServerVar('hosties_version', 1.5, 'Hosties Server Control by Bonbon').makepublic()
sv = es.ServerVar
hostie_rules = []

class LastRequest(object):

	def __init__(self):
		self.players = {}
		self.lastrequest = False
		self.t = None
		self.ct = None
		self.lrwinner = None
		self.start1 = None
		self.start2 = None
		self.race_end = None

	def can_lr(self, userid, ip=True):
		if playerlib.getPlayer(userid).get('isdead'):
			es.tell(userid, '#multi', '#lightgreen[Hosties]: #defaultYou have to be alive to use this feature!')
			return

		if not es.getplayerteam(userid) == 2:
			es.tell(userid, '#multi', '#lightgreen[Hosties]: #defaultYou have to be a terrorist to use the last request!')
			return

		if not len(playerlib.getPlayerList('#t,#alive')) <= int(sv('min_players_for_lr')):
			es.tell(userid, '#multi', '#lightgreen[Hosties]: #defaultThere are too many Terrorists!')
			return

		if self.lastrequest and ip:
			es.tell(userid, '#multi', '#lightgreen[Hosties]: #defaultThere is already a last request in progress!')
			return
		return True

	def initiate_request(self, userid):
		if self.can_lr(userid):
			popuplib.send('Last Request', userid)

	def S4S(self):
		es.msg('#multi', '#lightgreen[Hosties]: %s#default has chosen to have shot for shot with #lightgreen%s'%(es.getplayername(self.t), es.getplayername(self.ct)))
		playerlib.getPlayer(self.t).set('health', 100)
		playerlib.getPlayer(self.ct).set('health', 100)
		es.server.queuecmd('es_xgive %s weapon_deagle;es_xgive %s weapon_deagle'%(self.t, self.ct))
		self.beacon(self.t)
		self.beacon(self.ct)
		es.msg('#multi', '#lightgreen[Hosties]: #defaultThe two S4S contestants are beaconed, find a place to play S4S!')
		self.lastrequest = 'S4S'

	def GT(self):
		es.msg('#multi', '#lightgreen[Hosties]: %s#default has chosen to have a gun toss with #lightgreen%s!'%(es.getplayername(self.t), es.getplayername(self.ct)))
		self.beacon(self.t)
		self.beacon(self.ct)
		es.server.queuecmd('es_xgive %s weapon_deagle;es_xgive %s weapon_deagle'%(self.t, self.ct))
		es.msg('#multi', '#lightgreen[Hosties]: #defaultThe object of the game is to throw the deagle farther than the other player!')
		self.lrwinner = self.t
		

	def CF(self):
		es.msg('#multi', '#lightgreen[Hosties]: %s#default has chosen to have a chicken fight with #lightgreen%s'%(es.getplayername(self.t), es.getplayername(self.ct)))
		es.msg('#multi', '#lightgreen[Hosties]: #defaultThe object of the game is to get on the other players head!')
		es.msg('#multi', '#lightgreen[Hosties]: #defaultThe coding to check for people on head is not perfect, so don\'t always rely on it!')
		self.beacon(self.t)
		self.beacon(self.ct)

	def KF(self):
		es.msg('#multi', '#lightgreen[Hosties]: %s#default has chosen to have a knife fight with #lightgreen%s'%(es.getplayername(self.t), es.getplayername(self.ct)))
		playerlib.getPlayer(self.t).set('health', 100)
		playerlib.getPlayer(self.ct).set('health', 100)
		for userid in [self.t, self.ct]:
			es.server.queuecmd('es_xgive %s player_weaponstrip'%userid)
			es.server.queuecmd('es_xfire %s player_weaponstrip strip'%userid)
			es.server.queuecmd('es_xgive %s weapon_knife'%userid)
			self.beacon(userid)
		es.server.queuecmd('es_xfire %s player_weaponstrip kill'%userid)
		es.msg('#multi', '#lightgreen[Hosties]: #defaultPlayers are beaconed, you may fight!')

	def Race(self):
		es.msg('#multi', '#lightgreen[Hosties]: %s#default has chosen to have a race with #lightgreen%s'%(es.getplayername(self.t), es.getplayername(self.ct)))
		es.msg('#multi', '#lightgreen[Hosties]: #defaultgive #lightgreen%s#default some time to chose race points!'%es.getplayername(self.t))
		self.beacon(self.t)
		self.beacon(self.ct)
		popuplib.send('Chose Spawn Point 1', self.t)

	def race_effects(self):
		if self.lastrequest == 'Race':
			gamethread.delayedname(0.5, 'effect_loop', self.race_effects)
			if self.start1:
				effectlib.drawCircle(self.start1, 25, seconds=0.5, red=0, green=0, blue=255)
			if self.start2:
				effectlib.drawCircle(self.start2, 25, seconds=0.5, red=0, green=0, blue=255)
			if self.race_end:
				effectlib.drawCircle(self.race_end, 50, seconds=0.5, red=0, green=0, blue=255)
		else:
			self.start1 = self.start2 = self.race_end = None

	def start_race(self):
		es.msg('#multi', '#lightgreen[Hosties]: #defaultRace starts in #lightgreen3#default seconds!')
		messages = {0: '3', 1: '2', 2: '1', 3: 'GO!'}
		b = [self.start1, self.start2]
		l1 = random.choice(b)
		b.remove(l1)
		l2 = b[0]
		es.server.queuecmd('es_xsetpos %s %s %s %s'%(self.t, l1[0], l1[1], l1[2]))
		es.server.queuecmd('es_xsetpos %s %s %s %s'%(self.ct, l2[0], l2[1], l2[2]))
		playerlib.getPlayer(self.t).set('freeze', 1)
		playerlib.getPlayer(self.ct).set('freeze', 1)
		gamethread.delayedname(3, 'unfreeze', playerlib.getPlayer(self.t).set, ('noclip', 0))
		gamethread.delayedname(3, 'unfreeze', playerlib.getPlayer(self.ct).set, ('noclip', 0))
		for a in range(4):
			gamethread.delayedname(a, 'racemessage', es.centermsg, messages[a])
		gamethread.delayed(3, self.race_check_won_loop)

	def race_check_won_loop(self):
		if self.lastrequest == 'Race':
			gamethread.delayedname(0.05, 'check_race_won', self.race_check_won_loop)
			x, y, z = self.race_end
			for a in [self.t, self.ct]:
				x2, y2, z2 = es.getplayerlocation(a)
				x3, y3, z3 = x - x2, y - y2, z - z2
				if math.sqrt(math.pow(z3, 2) + math.pow(y3, 2) + math.pow(z3,2)) <= 3:
					es.msg('#multi', '#lightgreen[Hosties]: %s#default won the race!'%es.getplayername(a))
					self.lrwinner = a
					self.lastrequest = False
					break

	def check_chicken_won(self, userid):
		if self.lastrequest == 'CF':
			if userid in [self.t, self.ct]:
				if playerlib.getPlayer(self.t).get('distance', [self.ct, 'xy']) <= 40 and 180 >= playerlib.getPlayer(self.t).get('distance', [self.ct, 'z']) >= 60:
					es.msg('#multi', '#lightgreen[Hosties]: %s#default has lost the chicken fight!'%es.getplayername(self.ct))
					self.lrwinner = self.ct
					self.lastrequest = False
				elif playerlib.getPlayer(self.t).get('distance', [self.ct, 'xy']) <= 40 and 180 >= playerlib.getPlayer(self.ct).get('distance', [self.t, 'z']) >= 60:
					es.msg('#multi', '#lightgreen[Hosties]: %s#default has lost the chicken fight!'%es.getplayername(self.t))
					self.lastrequest = False
					self.lrwinner = self.t
				if not self.lastrequest:
					gamethread.cancelDelayed('beacon_%s'%self.t)
					gamethread.cancelDelayed('beacon_%s'%self.ct)

	def check_lr_won(self, userid, attacker, weapon):
		if self.lastrequest:
			if self.lastrequest == 'S4S':
				if userid in [self.t, self.ct] or attacker in [self.t, self.ct]:
					if not userid in [self.t, self.ct] or not attacker in [self.t, self.ct]:
						if userid == self.t:
							if not userid in Rb.rebels:
								es.msg('#multi', '#lightgreen[Hosties]: %s #defaulthas been killed by another CT!'%es.getplayername(userid))
								playerlib.getPlayer(attacker).set('health', 25)
								self.lastrequest = False
								return
						es.msg('#multi', '#lightgreen[Hosties]: %s #defaultis rebelling!'%es.getplayername(attacker))
						Rb.rebels.append(attacker)
						self.lastrequest = False
						return
					es.msg('#multi', '#lightgreen[Hosties]: %s #defaultwon the Shot for Shot!'%es.getplayername(attacker))
					self.lrwinner = attacker
					self.lastrequest = False
					gamethread.cancelDelayed('beacon_%s'%self.t)
					gamethread.cancelDelayed('beacon_%s'%self.ct)
			elif self.lastrequest == 'KF':
				if weapon == 'knife':
					if attacker == self.t:
						if userid == self.ct:
							es.msg('#multi', '#lightgreen[Hosties]: %s#default has won the Knife Fight!'%es.getplayername(attacker))
							self.lastrequest = False
							self.lrwinner = attacker
							return
						es.msg('#multi', '#lightgreen[Hosties]: %s#default is rebelling!'%es.getplayername(attacker))
						self.lastrequest = False
						Rb.rebels.append(attacker)
					elif attacker == self.ct:
						if userid == self.t:
							es.msg('#multi', '#lightgreen[Hosties]: %s #defaulthas won the Knife Fight!'%es.getplayername(attacker))
							self.lastrequest = False
				else:
					if attacker == self.t:
						es.msg('#multi', '#lightgreen[Hosties]: %s#default is rebelling!'%es.getplayername(self.t))
					elif attacker == self.ct:
						es.msg('#multi', '#lightgreen[Hosties]: %s#default used a gun in a knife fight!'%es.getplayername(self.ct))

	def beacon(self, userid):
		if not playerlib.getPlayer(userid).get('isdead'):
			if int(sv('beacon_on_lr')):
				if self.lastrequest:
					gamethread.cancelDelayed('beacon_%s'%userid)
					gamethread.delayedname(1, 'beacon_%s'%userid, self.beacon, userid)
					x, y, z = es.getplayerlocation(userid)
					es.server.queuecmd('est_effect 10 #a 0 "sprites/lgtning.vmt" %s %s %s 20 300 0.2 20 10 0 255 0 0 255 30'%(x, y, z))
					es.server.queuecmd('est_effect 10 #a 0.1 "sprites/lgtning.vmt" %s %s %s 20 300 0.3 15 10 0 255 150 150 255 30'%(x, y, z))
					es.emitsound('player', userid, 'buttons/blip2.wav', 0.8, 0.6)

LR = LastRequest()
lrfuncs = {
	'Shot For Shot': LR.S4S,
	'Gun Toss': LR.GT,
	'Chicken Fight': LR.CF,
	'Knife Fight': LR.KF,
	'Race': LR.Race,
}

class Rebel(object):

	def __init__(self):
		self.rebels = []
		self.ik = {}
		self.rebelchange = {}
		self.kps = {}
		self.on_heads = {}

	def player_death(self, userid, attacker, weapon):
		if userid in [LR.t, LR.ct] or attacker in [LR.t, LR.ct]:
			LR.lastrequest = False
		if es.getplayerteam(attacker) == 2:
			if attacker in self.on_heads:
				if self.on_heads[attacker] == userid:
					del self.on_heads[attacker]
					if weapon == 'knife':
						es.msg('#multi', '#lightgreen[Hosties]: %s#default killed #lightgreen%s#default for previously jumping on his/her head!'%(es.getplayername(attacker), es.getplayername(userid)))
						es.msg('#multi', '#lightgreen[Hosties]: #defaultDo NOT kill #lightgreen%s!'%es.getplayername(attacker))
						return
			if not attacker == LR.lrwinner:
				if int(sv('announce_turn_into_rebel')):
					if not attacker in self.rebels:
						es.msg('#multi', '#lightgreen[Hosties]: %s#default is now a rebel!'%es.getplayername(attacker))
				self.rebels.append(attacker)
			else:
				LR.lrwinner = None
				return
		self.check_rebel(userid)
		if userid in self.rebels:
			if int(sv('announce_rebel_killed')):
				es.msg('#multi', '#lightgreen[Hosties]: %s #defaultkilled a rebel!'%es.getplayername(attacker))
		if not userid in self.rebels:
			if es.getplayerteam(attacker) == 3:
				self.ik[attacker] = self.ik[attacker] + 1 if attacker in self.ik else 1
				if self.ik[attacker] >= int(sv('max_non_rebels_kill_per_round')):
					self.punish(attacker, str(sv('too_many_non_rebels_killed_punishment')))
				self.kps[attacker] = self.kps[attacker] + 1 if attacker in self.kps else 1
				gamethread.delayed(1.5, self.make_0, attacker)
				if self.kps[attacker] >= int(sv('max_innocent_kills_per_3_seconds')):
					self.punish(attacker, str(sv('too_high_kps_punishment')))
		gamethread.delayed(0, self.set_rebel_color, attacker)

	def set_rebel_color(self, attacker):
		if attacker in self.rebels:
			playerlib.getPlayer(attacker).set('color', str(sv('hosties_rebel_color')).split(','))

	def punish(self, userid, o):
		if o == 'slay':
			playerlib.getPlayer(userid).set('health', 0)
			es.server.queuecmd('es_xfire %s !self ignite'%userid)
		elif o == 'kick':
			es.server.queuecmd('kickid %s Don\'t line up and kill hosties!'%userid)
		elif o.startswith('takehp'):
			playerlib.getPlayer(userid).set('health', max(playerlib.getPlayer(userid).get('health') - int(o[6:]), 1))
		elif o == 'stripweapons':
			es.server.queuecmd('es_xgive %s player_weaponstrip'%userid)
			es.server.queuecmd('es_xfire %s player_weaponstrip strip'%userid)
			es.server.queuecmd('es_xfire %s player_weaponstrip kill'%userid)
		es.tell(userid, '#multi', '#lightgreen[Hosties]: #defaultDo not kill too many innocent hostages!')

	def make_0(self, userid):
		self.kps[userid] = 0

	def check_rebel(self, userid):
		if es.getplayerteam(userid) == 2:
			if not playerlib.getPlayer(userid).get('primary') == '0':
				self.rebels.append(userid)
			elif not playerlib.getPlayer(userid).get('primary') == '0':
				self.rebels.append(userid)

	def check_on_head(self, userid):
		if int(sv('allow_to_kill_for_jumping_on_head')):
			if es.getplayerteam(userid) == 3:
				for userid2 in playerlib.getUseridList('#t'):
					if playerlib.getPlayer(userid).get('distance', [userid2, 'xy']) <= 40 and 180 >= playerlib.getPlayer(userid).get('distance', [userid2, 'z']) >= 60:
						self.on_heads[userid2] = userid
						break

Rb = Rebel()

### Loads ###

def load():
	lrmenu = popuplib.easymenu('Last Request', '_popup_choice', lrmenu_select)
	sp1 = popuplib.easymenu('Chose Spawn Point 1', '_popup_choice', sp1_select)
	sp1.addoption('Add Starting Point', 'Add Starting Point') 
	sp2 = popuplib.easymenu('Chose Spawn 2', '_popup_choice', sp2_select)
	sp2.addoption('Add Starting Point', 'Add Starting Point')
	sp3 = popuplib.easymenu('Chose End Point', '_popup_choice', race_end_select)
	sp3.addoption('Chose Ending Point', 'Chose Ending Point')
	for option in ['Shot For Shot', 'Gun Toss', 'Chicken Fight', 'Knife Fight', 'Race']:
		lrmenu.addoption(option, option)
	es.addons.registerClientCommandFilter(_restrict_weapons)
	for option in sv_options:
		es.ServerVar(option).set(sv_options[option])
	if os.path.isfile(es.getAddonPath('hosties') + '/hosties.cfg'):
		es.server.queuecmd('es_xmexec ../addons/eventscripts/hosties/hosties.cfg')
	else:
		es.dbgmsg(0, 'Could not execute hosties.cfg!')
	if not es.exists('command', 'hosties_rule'):
		es.regcmd('hosties_rule', 'hosties/hosties_rule')
	gamethread.delayed(0.1, set_rules)
	hosties_menu = popuplib.easymenu('Hosties', '_popup_choice', hosties_select)
	for option in ['Rules', 'Commands']:
		hosties_menu.addoption(option, option)
	command_menu = popuplib.easymenu('Commands', '_popup_choice', command_select)
	for option in ['!lr', '!rules']:
		command_menu.addoption(option, option)

def unload():
	es.addons.unregisterClientCommandFilter(_restrict_weapons)
	for delay in ['effect_loop', 'racemessage', 'unfreeze', 'check_race_won']:
		gamethread.cancelDelayed(delay)

### Commands ###

def lastrequest():
	LR.initiate_request(es.getuserid())

### Events ###

def player_say(ev):
	if ev['text'].lower() == '!lr':
		LR.initiate_request(int(ev['userid']))
	elif ev['text'].lower() == '!rules':
		popuplib.send('Rules', ev['userid'])

def player_death(ev):
	LR.check_lr_won(int(ev['userid']), int(ev['attacker']), ev['weapon'])
	Rb.player_death(int(ev['userid']), int(ev['attacker']), ev['weapon'])
	if len(playerlib.getPlayerList('#t,#alive')) == int(sv('min_players_for_lr')):
		if int(sv('hosties_announce_lr_available')):
			es.msg('#multi', '#lightgreen[Hosties]: #defaultTerrorists can now type #lightgreen!lr#default for their last request!')

def player_activate(ev):
	if int(sv('hosties_show_rules_on_join')):
		popuplib.send('Hosties', ev['userid'])

def player_jump(ev):
	gamethread.delayed(0.3, LR.check_chicken_won, int(ev['userid']))
	gamethread.delayed(0.3, Rb.check_on_head, int(ev['userid']))

def round_end(ev):
	LR.lastrequest = False
	LR.ct = None
	LR.t = None
	Rb.rebels = []
	Rb.ik.clear()
	LR.lrwinner = None
	Rb.on_heads.clear()
	for userid in es.getUseridList():
		gamethread.cancelDelayed('beacon_%s'%userid)

def player_disconnect(ev):
	u = int(ev['userid'])
	if u in Rb.kps:
		del Rb.kps[u]
	if u in Rb.ik:
		del Rb.ik[u]

def item_pickup(ev):
	if not ev['item'] in str(sv('unrestricted_weapons')):
		handle = es.getplayerhandle(ev['userid'])
		for index in es.createentitylist('weapon_%s'%ev['item']):
			if handle == es.getindexprop(index, "CBaseEntity.m_hOwnerEntity"):
				es.server.queuecmd('es_xremove %s'%index)
				es.tell(ev['userid'], '#multi', '#lightgreen[Hosties]: #defaultSorry, the #lightgreen%s#default is restricted'%ev['item'])
				es.cexec(ev['userid'], 'lastinv')
				break

def player_spawn(ev):
	if es.getplayerteam(ev['userid']) == 2:
		if int(sv('strip_weapons_on_round_end')):
			es.server.queuecmd('es_xgive %s player_weaponstrip'%ev['userid'])
			es.server.queuecmd('es_xfire %s player_weaponstrip strip'%ev['userid'])
			es.server.queuecmd('es_xfire %s player_weaponstrip kill'%ev['userid'])
		for weapon in str(sv('t_start_weapons')).split(','):
			es.server.queuecmd('es_xgive %s weapon_%s'%(ev['userid'], weapon))
	elif es.getplayerteam(ev['userid']) == 3:
		for weapon in str(sv('ct_start_weapons')).split(','):
			es.server.queuecmd('es_xgive %s weapon_%s'%(ev['userid'], weapon))

def player_hurt(ev):
	if not playerlib.getPlayer(ev['userid']).get('isdead'):
		if not str(sv('hosties_announce_ct_hurt_t')) == '0':
			if es.getplayerteam(ev['attacker']) == 3:
				if es.getplayerteam(ev['userid']) == 2:
					Rb.check_rebel(int(ev['userid']))
					if not int(ev['userid']) in Rb.rebels:
						if str(sv('hosties_announce_ct_hurt_t')) == 'tell':
							es.tell(ev['userid'], '#multi', '#lightgreen[Hosties]: %s#default attacked you!'%es.getplayername(ev['attacker']))
						else:
							es.msg('#multi', '#lightgreen[Hosties]: %s#default attacked #lightgreen%s'%(es.getplayername(ev['attacker']), es.getplayername(ev['userid'])))
		if not int(ev['attacker']) in Rb.rebels:
			if int(sv('hosties_rebel_on_hurt')):
				if es.getplayerteam(ev['userid']) == 3 and es.getplayerteam(ev['attacker']) == 2:
					if int(ev['attacker']) == LR.t and not int(ev['userid']) == LR.ct:
						LR.lastrequest = False
						es.msg('#multi', '#lightgreen[Hosties]: %s#default is rebelling!'%es.getplayername(ev['attacker']))
						Rb.rebels.append(int(ev['attacker']))
					elif not int(ev['attacker']) == LR.t:
						if not int(ev['attacker']) in Rb.on_heads:
							es.msg('#multi', '#lightgreen[Hosties]: %s#default is rebelling!'%es.getplayername(ev['attacker']))
							Rb.rebels.append(int(ev['attacker']))

### Popup Selects ###

def lrmenu_select(userid, choice, popupid):
	if LR.can_lr(userid):
		choseplayer = popuplib.easymenu('Chose Player', '_popup_choice', choseplayer_select)
		for userid2 in playerlib.getUseridList('#ct,#alive'):
			choseplayer.addoption([choice, userid2], es.getplayername(userid2))
		popuplib.send('Chose Player', userid)

def choseplayer_select(userid, choice, popupid):
	if not es.exists('userid', choice[1]):
		es.tell(userid, '#multi', '#lightgreen[Hosties]: #defaultTarget has left the server!')
		return

	if playerlib.getPlayer(choice[1]).get('isdead'):
		es.tell(userid, '#multi', '#lightgreen[Hosties]: #defaultTarget is now dead!')
		return

	if LR.can_lr(userid):
		LR.t = userid
		LR.ct = choice[1]
		LR.lastrequest = {'Shot For Shot': 'S4S', 'Gun Toss': 'GT', 'Chicken Fight': 'CF', 'Knife Fight': 'KF', 'Race': 'Race'}[choice[0]]
		lrfuncs[choice[0]]()

def rules_select(userid, choice, popupid):
	popuplib.send('Rules', userid)

def hosties_select(userid, choice, popupid):
	popuplib.send(choice, userid)

def command_select(userid, choice, popupid):
	replies = {
		'!lr': 'Type !lr to get your last request if you\'re one of the last Ts!',
		'!rules': 'Type !rules to see the rules/how to play menu'
	}
	es.tell(userid, '#multi', '#lightgreen[Hosties]: #default' + replies[choice])

def sp1_select(userid, choice, popupid):
	if LR.can_lr(userid, False):
		LR.start1 = es.getplayerlocation(userid)
		LR.race_effects()
		popuplib.send('Chose Spawn 2', userid)

def sp2_select(userid, choice, popupid):
	if LR.can_lr(userid, False):
		x, y, z = es.getplayerlocation(userid)
		x2, y2, z2 = LR.start1
		x3, y3, z3 = x - x2, y - y2, z - z2
		if 80 >= math.sqrt(math.pow(z3,2) + math.pow(y3,2)) >= 30 and abs(z - z2) <= 50:
			LR.start2 = x, y, z
			popuplib.send('Chose End Point', userid)
		else:
			es.tell(userid, '#multi', '#lightgreen[Hosties]: #defaultPlease make the two spawn points between 30 and 80 game units apart, current is %s'%math.sqrt(math.pow(z3,2) + math.pow(y3,2)))
			popuplib.send('Chose Spawn 2', userid)

def race_end_select(userid, choice, popupid):
	if LR.can_lr(userid, False):
		x, y, z = es.getplayerlocation(userid)
		x2, y2, z2 = LR.start1
		x3, y3 = x - x2, y - y2
		if math.sqrt(math.pow(x3, 2) + math.pow(y3, 2)) >= 400:
			LR.race_end = x, y, z
			LR.start_race()
		else:
			es.tell(userid, '#multi', '#lightgreen[Hosties]: #defaultLocation to close to starting points!')
			popuplib.send('Chose End Point', userid)
			

### Misc ###

def _restrict_weapons(userid, args):
	if args[0].lower() == 'buy':
		if not args[1].lower() in str(sv('unrestricted_weapons')):
			return False
	return True

def set_rules():
	rulemenu = popuplib.easymenu('Rules', '_popup_choice', rules_select)
	for rule in hostie_rules:
		rulemenu.addoption(rule, rule)

### Commands ###

def hosties_rule():
	args = es.getargs()
	if not args:
		es.dbgmsg(0, 'Need more args to add rules!')
		return
	hostie_rules.append(args)
	set_rules()


